local anim8 = require "module/anim8/anim8"
AniObj = class("AniObj", WorldObj)

function AniObj:initialize(duration, skin, x, y, z)
	local g = anim8.newGrid(Map.BlockSize, Map.BlockSize, Map.BlockSize * 4, Map.BlockSize)
	self.animation = anim8.newAnimation("loop", g('1-4,1'), 0.01)
	WorldObj.initialize(self, skin, x, y, z)
	self.duration = duration
	self.layer = 2
end

function AniObj:update(dt)
	self.duration = self.duration - dt
	self.animation:update(dt)
	if self.duration < 0 then
		self.dead = true
	end
end

function AniObj:draw(offx, offy)
	local px, py = self:toPixel(offx, offy)
	self.animation:draw(WorldObj.Skin[self.skin], px, py)
end
